///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <string.h>
#include <stdlib.h>
#include <math.h>

#ifndef __RDRTIME_HPP
#include "rdrtime.hpp"
#endif

#ifndef __HOSEUTIL_HPP
#include "hoseutil.hpp"
#endif

short RdRtime::AnalysDataBlocks()
{{
    short          error = COLLECTING_DATA;
    unsigned short residual;

		if(rtc.index_static_buf==rtc.len_static_buf) 
    { f_fillbuf=0;
      if (rec_type_code==MICRO_Z) com.cnbyte=512;
			return(COLLECTING_DATA);/*FILLBUF;*/ 
    }

    if(rtc.index_static_buf+rdd.fill_byte-rtc.beg_buf > rtc.len_static_buf)
    { rtc.beg_buf=rtc.len_static_buf-rtc.index_static_buf;
      memcpy((char *)bf.ibf,&bf.vibf[rtc.index_static_buf],rtc.beg_buf);
			f_fillbuf=0;
      if (rec_type_code==MICRO_Z) com.cnbyte=512;
			return(COLLECTING_DATA);/*FILLBUF;*/ 
    }
    else
    { if(rtc.beg_buf)
      { residual=rdd.fill_byte-rtc.beg_buf;
				memcpy(&bf.ibf[rtc.beg_buf],&bf.vibf[rtc.index_static_buf],residual);
				rtc.index_static_buf+=residual;
				rtc.beg_buf=0;
      }
      else
      {	memcpy((char *)bf.ibf,&bf.vibf[rtc.index_static_buf],rdd.fill_byte);
				rtc.index_static_buf+=rdd.fill_byte;
			}
      bf.ibf[rdd.fill_byte]='\0';

      if (rec_type_code==MICRO_Z)
      {	if ((rdd.fill_byte==4)&&(fa.data_type==NO_TYPE_HEADER))
      		Identification_data_type();
				else
				{	error=Read_data_fromRawfile();
					if (error!=TRANS_OK) return(error);
				}	      			
      }
		}

    if (error==TRANS_OK) error=COLLECTING_DATA;
    return(error);
}}

// CALL 
// only if f_fillbuf=0 (end AnalysDataBlocks and begin ReadBlocks or end write file) !!!
// else f_fillbuf=1 and AnalysDataBlocks return COLLECTING_DATA or ERROR_... !!! 
short RdRtime::EndReadFile(short error)
{{ 
  short verror=error;

	if ((verror!=TRANS_OK)&&(verror!=COLLECTING_DATA)&&(vmem.num_blocks==vmem.sum_blocks))
    if (rtc.len_static_buf-rtc.index_static_buf<=512) 
    { verror=COLLECTING_DATA;
      f_fillbuf=-1; // end write curr. file !!!
    }
  
	if (verror==COLLECTING_DATA)
    if (vmem.num_blocks==vmem.sum_blocks) 
      f_fillbuf=-1; // end write curr. file !!!
  
  if (((fa.curr_file_type==RANGER_MODE2)||(fcf.f_createCfile==1))&&(f_fillbuf==-1))
    f_fillbuf=2; // rewrite header C-file !!! 
  else
		if ((f_fillbuf==-1)&&(rec_type_code==MICRO_Z))
			f_fillbuf=3;			  	  
    
  rtc.index_static_buf=0;  
	return(verror);
}}  

