///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#ifndef __HOSEUTIL_HPP
#include "hoseutil.hpp"
#endif

static char *types_rcv[19] =  
{ "  ",   "LM\0",
	"MS\0", "Mx\0",
	"Dx\0", "Px\0",
	"3x\0", "Rx\0",
	"Zx\0", "SC\0",
	"SE\0", 
	
	"G1\0",	"OZ\0",
	"G2\0",
	
	"UZ\0",	"LC\0", 
	"H4\0",	"18\0",
	"GG\0"
};

static char *ext_types_rcv[19] =  
{ "UNKN\0",     "LM-XII\0",
	"MS-XII\0",   "M-XII\0",
	"D-XII\0" ,   "P-XII\0" ,
	"3DF\0",      "RANGER\0",
	"Z-XII\0",    "SUPER-CA\0",
	"LCS-XII\0",  
	
	"G-XII\0",		"Vispa\0",
	"G-XXIV\0",
	
	"MicroZ\0",		"LOCUS\0",
	"HP-48\0",		"Z-18\0",
	"GGG\0"
};


char *ReceiverName( short _receiver_index )
{{
  return ( _receiver_index > 0 && _receiver_index < 19 ) ?
	 ext_types_rcv[_receiver_index] : ext_types_rcv[0];
}}

char *ReceiverNameEcho( short _receiver_index )
{{
  return ( _receiver_index > 0 && _receiver_index < 19 ) ?
	 types_rcv[_receiver_index] : types_rcv[0];
}}

