#!/usr/bin/perl
#
# FILE:        mdm-lib.pl
#
# DESCRIPTION: This script contains some useful subroutines
#              for email related scripts.
#
#############################################################


############################################################################
#
# Subroutine: SendMail
#
# Description: Sends result of testing to specified receipients.
#
############################################################################
sub SendMail {

    my ($EmailFile, $LogFile, $command, $EmailList) = @_;

    Compact_UUE_File ($LogFile);        
    $SysCmd = "cat $EmailFile $LogFile\.uue | mail -s " . '"' . $command . '" ' . $EmailList;
    system ($SysCmd);
    unlink ($LogFile); # we have already sent a zip file via email.
    unlink ($EmailFile);
}


############################################################################
#
# Subroutine: PrintTimeHeader
#
# Description: 
#
############################################################################
sub PrintTimeHeader {
    my ($FileName, $first, $second) = @_;
    my $Line;
    
    # Build command string
    $Line = $first . localtime() . "\n" . $second;

    open (FILEHANDLE, ">>$FileName");
    print FILEHANDLE $Line; 
    close (FILEHANDLE);

}


############################################################################
#
# Subroutine: Compact_UUE_File
#
# Description: 
#
############################################################################
sub Compact_UUE_File {
    ($FileName) = @_;

    $Command = "cat $FileName | gzip > $FileName\.gz";
    system ($Command);
    $Command = "uuencode $FileName\.gz $FileName\.gz > $FileName\.uue";
    system ($Command);
}


############################################################################
#
# Subroutine: WriteToFile
#
# Description: 
#
############################################################################
sub WriteToFile {
    my ($FileName, $Line) = @_;

    open (FILEHANDLE, ">>$FileName");
    print FILEHANDLE $Line; 
    close (FILEHANDLE);
}


############################################################################
#
# Subroutine: MyEcho
#
# Description: 
#
############################################################################

sub MyEcho {
    ($FileName, $FirstLine, $SecondLine) = @_;

    $FirstLine = $FirstLine . localtime ();
    system ("echo $FirstLine > $FileName");
    system ("echo $SecondLine >> $FileName");
    # Added a blank line.
    system ("echo >> $FileName");
}


# This line has to be the very last line of the module, for some 
# obscured for me reason 
1; #return true , to please the require satement in main module
